unit Unit1;

interface

uses
  System.SysUtils,
  System.Classes,
  JS,
  Web,
  WEBLib.Modules,
  App.Config,
  XData.Web.Connection,
  XData.Web.Client;

type

  TDataModule1 = class(TWebDataModule)
    WebClient: TXDataWebClient;
    DataConnection: TXDataWebConnection;
    procedure WebDataModuleCreate(Sender: TObject);
  private
    { Private declarations }
    [Async]
    procedure InitModule;
  public
    { Public declarations }
  end;

var
  DataModule1: TDataModule1;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

uses
  WEBLib.Rest,
  XData.Web.Request,
  XData.Web.Response;

{$R *.dfm}

procedure TDataModule1.InitModule;

  procedure OnSuccess(Response: IHttpResponse);
  var
    Obj: TJSObject;
    lResponse: string;
  begin
    if Response.StatusCode = 200 then
    begin
      AppConfig.Load(Response.ContentAsText);
      DataConnection.URL := AppConfig.BaseUrl;
      // SphinxLogin.Authority := Config.AuthURL;
      // SphinxLogin.Login;
    end;
  end;

  procedure OnError;
  begin
    AppConfig.BaseUrl := '';
    AppConfig.AuthURL := '';
  end;

var
  Conn: TXDataWebConnection;
  Response: IHttpResponse;
begin

  Conn := TXDataWebConnection.Create(nil);
  try
    Conn.SendRequest(THttpRequest.Create('config/config.json'), @OnSuccess, @OnError);

    Response := TAwait.Exec<IHttpResponse>(Conn.SendRequestAsync(THttpRequest.Create('config/config.json')));

    if Response.StatusCode = 200 then
    begin
      AppConfig.Load(Response.ContentAsText);

      DataConnection.URL := AppConfig.BaseUrl;
      // SphinxLogin.Authority := Config.AuthURL;
      // SphinxLogin.Login;
    end;

  finally
    Conn.Free;
  end;

end;

procedure TDataModule1.WebDataModuleCreate(Sender: TObject);
begin
  InitModule;
end;

end.
